#pragma once
#include "Thing.h"
#include "Header.h"

class Lives :
	public Thing
{
private:
	SDL_Surface *lives;
	SDL_Rect LivesTarget;
	SDL_Texture * LivesTexture;
	SDL_Color textColor;
public:
	virtual void initiate(int i) {
		SDL_FreeSurface(lives);
		SDL_DestroyTexture(LivesTexture);
		textColor = { 255, 255, 255 };
		lives = TTF_RenderText_Solid(font, "LIVES : ", textColor);
		LivesTexture = SDL_CreateTextureFromSurface(renderer, lives);
		LivesTarget.x = 900; LivesTarget.y = 10; LivesTarget.h = 20; LivesTarget.w = 80;
	}
	virtual void update(int i) {
		SDL_RenderCopy(renderer, LivesTexture, NULL, &LivesTarget);
	}
	virtual void destroy(int i) {
		SDL_FreeSurface(lives);
		SDL_DestroyTexture(LivesTexture);
	}
	Lives()
	{
	}

	~Lives()
	{
	}
};

