#pragma once
#include "Thing.h"
class LivesFigure :
	public Thing

#include "Header.h"
#include <string>
{
private:
	SDL_Surface *livesFigure;
	SDL_Rect livesFigureTarget;
	SDL_Texture * livesFigureTexture;
	SDL_Color textColor;
	//int lives;
	std::string livesString;
	const char *LIVES;
public:
	virtual void initiate(int i) {
		livesFigureTarget.x = 980; livesFigureTarget.y = 10; livesFigureTarget.h = 20; livesFigureTarget.w = 10;
		textColor = { 255, 255, 255 };
	}
	virtual void update(int i) {
		SDL_DestroyTexture(livesFigureTexture);
		SDL_FreeSurface(livesFigure);
		//lives = globalLives;
		livesString = std::to_string(lives);
		LIVES = livesString.c_str();
		livesFigure = TTF_RenderText_Solid(font, LIVES, textColor);
		livesFigureTexture = SDL_CreateTextureFromSurface(renderer, livesFigure);
		SDL_RenderCopy(renderer, livesFigureTexture, NULL, &livesFigureTarget);
	}
	virtual void destroy(int i) {
		SDL_DestroyTexture(livesFigureTexture);
		SDL_FreeSurface(livesFigure);
	}
	LivesFigure()
	{
	}

	~LivesFigure()
	{
	}
};

