#pragma once
#include "Thing.h"
#include "Header.h"

class Tako :
	public Thing
{
private:
	SDL_Rect takoSource;
	//SDL_Rect takoTarget;
	//bool firstLaser = true;
	bool shooting = false;
	SDL_bool collides;
	int i;
	int u;
	int z;
	int zuffi;
	int takoFrame = 0;
public:
	bool front = false;
	bool dead = false;
	
	virtual void initiate(int i) {
		dead = false;
		front = false;
		shooting = false;
		collides = SDL_FALSE;
		takoSource.x = 0; takoSource.y = 0 + ((stage-1)*40); takoSource.w = 50; takoSource.h = 40;
		takoTarget[i - 414].w = 50; takoTarget[i - 414].h = 40;
		if ((i-414) < 11) {
			takoTarget[i - 414].x = 70 + ((i-414) * 65);
			takoTarget[i - 414].y = 235 + levelup;
		}
		else {
			takoTarget[i - 414].x = 70 + (((i-414) - 11) * 65);
			takoTarget[i - 414].y = 235 + 45 + levelup;
		}
		//takoRect[i-414] = takoTarget;
	}
	virtual void update(int i) {
		if (dead == false) {
			if (go == true) {
				if (takoFrame == 0) takoFrame = 1;
				else takoFrame = 0;
				if (takoFrame == 0)
					takoSource.x = 0;
				else
					takoSource.x = 50;
				if (left == true) takoTarget[i - 414].x = takoTarget[i - 414].x - 10;
				else if (right==true) takoTarget[i - 414].x = takoTarget[i - 414].x + 10;
				else if (down == true){
					takoTarget[i - 414].y = takoTarget[i - 414].y + 16;
					wentDown = true;
				}

				collides = SDL_HasIntersection(&takoTarget[i - 414], &LeftBorder);
				if (collides == SDL_TRUE && wentDown == false) {
				nextDownthenRight = true;
				}
				collides = SDL_HasIntersection(&takoTarget[i - 414], &RightBorder);
				if (collides == SDL_TRUE && wentDown == false) {
					nextDownthenLeft = true;
				}
				//takoRect[i - 414] = takoTarget;
				
				u = ((i - 414) * 4) + 1520;
				FragmentTarget[u].x = takoTarget[i - 414].x; FragmentTarget[u].y = takoTarget[i - 414].y;//top Left
				FragmentTarget[u + 1].x = takoTarget[i - 414].x + 25; FragmentTarget[u + 1].y = takoTarget[i - 414].y;//top Right
				FragmentTarget[u + 2].x = takoTarget[i - 414].x; FragmentTarget[u+2].y = takoTarget[i - 414].y + 20;//bottom Left
				FragmentTarget[u + 3].x = takoTarget[i - 414].x + 25; FragmentTarget[u+3].y = takoTarget[i - 414].y + 20;//bottom Right
			
			}
			collides = SDL_HasIntersection(&takoTarget[i - 414], &PlayerLaserRect);
			if (collides == SDL_TRUE) {
				dead = true; 
				score = score + 10;
				EnemiesLeft = EnemiesLeft - 1;
				PlayerlaserCollide = true;
				PlayershotFired = false;
				PlayerLaserRect.x = 0;
				PlayerLaserRect.y = 0;
				moveTreshold = moveTreshold - 9000000;
				u = ((i - 414) *4) +1520;
				fragmentActive[u] = true; fragmentActive[u + 1] = true; fragmentActive[u + 2] = true; fragmentActive[u + 3] = true;
				explosionActive[i - 381] = true;
				explosionTarget[i - 381] = takoTarget[i - 414];
				for (z = 0; z < 32; z++) {
					if (FX_QUEUE[z] == SILENCE_PUSH) {
						FX_QUEUE[z] = ENEMYEXPLOSION_PUSH;
						break;
					}
				}
			}
			if (dead == false && front == true && shooting == false) {
				srand(SDL_GetTicks()*(SDL_GetTicks()*(time(NULL))*time(NULL)));
				zuffi = rand() % 200 + 1;
				if (zuffi == i - 400) {
					enemyLaserActive[i - 414] = true;
					enemyLaserStartX[i - 414] = takoTarget[i - 414].x + 25; enemyLaserEndX[i - 414] = enemyLaserStartX[i - 414];
					enemyLaserStartY[i - 414] = takoTarget[i - 414].y + 40; enemyLaserEndY[i - 414] = takoTarget[i - 414].y + 40;
					enemyLaserRect[i - 414].x = enemyLaserStartX[i - 414]; enemyLaserRect[i - 414].y = enemyLaserStartY[i - 414]; enemyLaserRect[i - 414].w = 3; enemyLaserRect[i - 414].h = 20;
					shooting = true; enemyLaserActive[i - 414] = true;
				}
			}
			if (dead == false) {
				SDL_RenderCopy(renderer, takoTexture, &takoSource, &takoTarget[i - 414]);
				if (enemyLaserActive[i - 414] == false) shooting = false;
			}
		}
	}
	
	Tako()
	{
	}
	~Tako()
	{
	}
};

