#pragma once
#include "Header.h"
#include "Thing.h"
class youdeadSAD :
	public Thing
{
private:
	SDL_Surface *youDeadSAD;
	SDL_Rect youdeadSADTarget;
	SDL_Texture * youdeadSADTexture;
	SDL_Color textColor;
	std::chrono::steady_clock::time_point start;
	std::chrono::steady_clock::time_point finish;
	long double timeElapsed = 0;
public:
	virtual void initiate(int i) {
		SDL_FreeSurface(youDeadSAD);
		SDL_DestroyTexture(youdeadSADTexture);
		textColor = { 255, 255, 255 };
		youDeadSAD = TTF_RenderText_Solid(font, "YOU DEAD. SAD!", textColor);
		youdeadSADTexture = SDL_CreateTextureFromSurface(renderer, youDeadSAD);
		youdeadSADTarget.x = 300; youdeadSADTarget.y = 200; youdeadSADTarget.h = 80; youdeadSADTarget.w = 400;
	}
	virtual void update(int i) {
		if (playerHit == true) {
			SDL_RenderCopy(renderer, youdeadSADTexture, NULL, &youdeadSADTarget);
			SDL_RenderPresent(renderer);
			start = std::chrono::steady_clock::now();
			while (true) {
				finish = std::chrono::steady_clock::now();
				timeElapsed = std::chrono::duration_cast<std::chrono::nanoseconds>(finish - start).count();
				if (timeElapsed >= 3000000000) break;
			}
			playerHit = false;
		}
	}
	virtual void destroy(int i) {
		SDL_FreeSurface(youDeadSAD);
		SDL_DestroyTexture(youdeadSADTexture);
	}
	youdeadSAD()
	{
	}
	~youdeadSAD()
	{
	}
};

