#pragma once
#include "Thing.h"
#include "Header.h"
class Fragment :
	public Thing
{
private:
	SDL_Texture * FragmentTexture;
	SDL_Surface * FragmentSurface;
	SDL_Rect FragmentSource;
	//SDL_Rect FragmentTarget[i-438];
	bool topLeft = false;
	bool topRight = false;
	bool bottomLeft = false;
	bool bottomRight = false;
	bool midLeft = false;
	bool midRight = false;
	//bool active = false;
	bool isLeg = false;
	bool middle = false;
	int barrierCollisions = 0;
	//int LegStartX;
	//int LegStartY;
	//int LegEndX;
	//int LegEndY;
	int rotateCount = 0;

public:

	virtual void initiate(int i) { //thing 437 UFO, also fragments 438-2247
		//Barrier from 438 (0) to 1957 (1519)
		//active = false;
		rotateCount = 0;
		fragmentActive[i - 438] = false;
		SDL_FreeSurface(FragmentSurface);
		SDL_DestroyTexture(FragmentTexture);
		if (i < 1958) {
			FragmentTexture = SDL_CreateTextureFromSurface(renderer, barrierSurface);
			FragmentTarget[i - 438].h = 5; FragmentTarget[i - 438].w = 5;
			FragmentSource.h = 5; FragmentSource.w = 5;
			if (((1954 - i) % 4) == 0) { //Top Left
				topLeft = true;
				FragmentSource.x = 0; FragmentSource.y = 0+ (stage - 1) * 10;;
				FragmentTarget[i - 438].x = BarrierTarget[(i - 438) / 4].x; FragmentTarget[i - 438].y = BarrierTarget[(i - 438) / 4].y;
			}
			else if (((1955 - i) % 4) == 0) {//Top Right
				topRight = true;
				FragmentSource.x = 5; FragmentSource.y = 0+(stage - 1) * 10;
				FragmentTarget[i - 438].x = BarrierTarget[(i - 438) / 4].x + 5; FragmentTarget[i - 438].y = BarrierTarget[(i - 438) / 4].y;
			}
			else if (((1956 - i) % 4) == 0) {//Bottom Left
				bottomLeft = true;
				FragmentSource.x = 0; FragmentSource.y = 5+ (stage - 1) * 10;
				FragmentTarget[i - 438].x = BarrierTarget[(i - 438) / 4].x; FragmentTarget[i - 438].y = BarrierTarget[(i - 438) / 4].y + 5;
			}
			else if (((1957 - i) % 4) == 0) {//Bottom Right
				bottomRight = true;
				FragmentSource.x = 5; FragmentSource.y = 5+ (stage - 1) * 10;
				FragmentTarget[i - 438].x = BarrierTarget[(i - 438) / 4].x + 5; FragmentTarget[i - 438].y = BarrierTarget[(i - 438) / 4].y + 5;
			}
		}
		//TAKO FRAGMENTS, 4 PIECES FOR EACH INSTANCE 
		else if (i > 1957 && i < 2046) {
			FragmentTexture = SDL_CreateTextureFromSurface(renderer, takoSurface);
			FragmentTarget[i - 438].h = 20; FragmentTarget[i - 438].w = 25;
			FragmentSource.h = 20; FragmentSource.w = 25;
			if (((2042 - i) % 4) == 0) { //Top Left
				topLeft = true;
				FragmentSource.x = 0; FragmentSource.y = 0 + ((stage - 1) * 40);
				FragmentTarget[i - 438].x = takoTarget[(i - 1958) / 4].x; FragmentTarget[i - 438].y = takoTarget[(i - 1958) / 4].y;
			}
			else if (((2043 - i) % 4) == 0) {//Top Right
				topRight = true;
				FragmentSource.x = 25; FragmentSource.y = 0 + ((stage - 1) * 40);
				FragmentTarget[i - 438].x = takoTarget[(i - 1958) / 4].x + 25; FragmentTarget[i - 438].y = takoTarget[(i - 1958) / 4].y;
			}
			else if (((2044 - i) % 4) == 0) {//Bottom Left
				bottomLeft = true;
				FragmentSource.x = 0; FragmentSource.y = 20 + ((stage - 1) * 40);
				FragmentTarget[i - 438].x = takoTarget[(i - 1958) / 4].x; FragmentTarget[i - 438].y = takoTarget[(i - 1958) / 4].y + 20;
			}
			else if (((2045 - i) % 4) == 0) {//Bottom Right
				bottomRight = true;
				FragmentSource.x = 25; FragmentSource.y = 20 + ((stage - 1) * 40);
				FragmentTarget[i - 438].x = takoTarget[(i - 1958) / 4].x + 25; FragmentTarget[i - 438].y = takoTarget[(i - 1958) / 4].y + 20;
			}
		}
		//TRIPOD LEGS FRAGMENTS, 1 FOR EACH LEG
		else if (i > 2045 && i < 2112) {
			isLeg = true;
			if (((1671 - i) % 3) == 0) {
				bottomLeft = true;
				//LegStartX = fragmentLegStartX[i - 2046];
				//LegEndY = fragmentLegEndY[i - 2046];
			}
			else if (((1672 - i) % 3) == 0) {
				middle = true;
				//LegStartX = fragmentLegStartX[i - 2046 +1];
				//LegEndY = fragmentLegEndY[i - 2046 + 1];
			}
			else if (((1673 - i) % 3) == 0) {
				bottomRight = true;
				//LegStartX = fragmentLegStartX[i - 2046 + 2];
				//LegEndY = fragmentLegEndY[i - 2046 + 2];
			}
		}
		//TRIPOD BODY FRAGMENTS, 4 FOR EACH INSTANCE
		else if (i > 2111 && i < 2200) {
			FragmentTexture = SDL_CreateTextureFromSurface(renderer, tripodBodySurface);
			FragmentTarget[i - 438].h = 14; FragmentTarget[i - 438].w = 25;
			FragmentSource.h = 14; FragmentSource.w = 25;
			if (((1758 - i) % 4) == 0) {
				topLeft = true;
				FragmentSource.x = 0; FragmentSource.y = 0 + (stage-1)*28;
				FragmentTarget[i - 438].x = tripodBodyTarget[(88 - (2199 - i)) / 4].x; FragmentTarget[i - 438].y = tripodBodyTarget[(88 - (2199 - i)) / 4].y;
			}
			else if (((1759 - i) % 4) == 0) {//Top Right
				topRight = true;
				FragmentSource.x = 25; FragmentSource.y = 0+(stage - 1) * 28;
				FragmentTarget[i - 438].x = tripodBodyTarget[(88 - (2199 - i)) / 4].x + 25; FragmentTarget[i - 438].y = tripodBodyTarget[(88 - (2199 - i)) / 4].y;
			}
			else if (((1760 - i) % 4) == 0) {//middle Left
				midLeft = true;
				FragmentSource.x = 0; FragmentSource.y = 14 + (stage - 1) * 28;
				FragmentTarget[i - 438].x = tripodBodyTarget[(88 - (2199 - i)) / 4].x; FragmentTarget[i - 438].y = tripodBodyTarget[(88 - (2199 - i)) / 4].y + 14;
			}
			else if (((1761 - i) % 4) == 0) {//middle Right
				midRight = true;
				FragmentSource.x = 25; FragmentSource.y = 14 + (stage - 1) * 28;
				FragmentTarget[i - 438].x = tripodBodyTarget[(88 - (2199 - i)) / 4].x + 25; FragmentTarget[i - 438].y = tripodBodyTarget[(88 - (2199 - i)) / 4].y + 14;
			}
		}
		//LITTLE GREY MEN FRAGMENTS, 4 FOR EACH
		else if (i > 2199 && i < 2244) {
			FragmentTexture = SDL_CreateTextureFromSurface(renderer, littleGreySurface);
			FragmentTarget[i - 438].h = 30; FragmentTarget[i - 438].w = 25;
			FragmentSource.h = 30; FragmentSource.w = 25;
			if (((1802 - i) % 4) == 0) {
				topLeft = true; //Top Left
				FragmentSource.x = 0; FragmentSource.y = 0 + ((stage - 1) * 60);
				FragmentTarget[i - 438].x = littleGreyTarget[(88 - (2243 - i)) / 4].x; FragmentTarget[i - 438].y = littleGreyTarget[(88 - (2243 - i)) / 4].y;
			}
			else if (((1803 - i) % 4) == 0) {//Top Right
				topRight = true;
				FragmentSource.x = 25; FragmentSource.y = 0 + ((stage - 1) * 60);
				FragmentTarget[i - 438].x = littleGreyTarget[(88 - (2243 - i)) / 4].x + 25; FragmentTarget[i - 438].y = littleGreyTarget[(88 - (2243 - i)) / 4].y;
			}
			else if (((1804 - i) % 4) == 0) {//bottom Left
				bottomLeft = true;
				FragmentSource.x = 0; FragmentSource.y = 14 + ((stage - 1) * 60);
				FragmentTarget[i - 438].x = littleGreyTarget[(88 - (2243 - i)) / 4].x; FragmentTarget[i - 438].y = littleGreyTarget[(88 - (2243 - i)) / 4].y + 30;
			}
			else if (((1805 - i) % 4) == 0) {//bottom Right
				bottomRight = true;
				FragmentSource.x = 25; FragmentSource.y = 14 + ((stage - 1) * 60);
				FragmentTarget[i - 438].x = littleGreyTarget[(88 - (2243 - i)) / 4].x + 25; FragmentTarget[i - 438].y = littleGreyTarget[(88 - (2243 - i)) / 4].y + 30;
			}
		}//UFO
		else if (i > 2243 && i < 2248) {
			FragmentTexture = SDL_CreateTextureFromSurface(renderer, UFOSurface);
			FragmentTarget[i - 438].h = 20; FragmentTarget[i - 438].w = 25;
			FragmentSource.h = 20; FragmentSource.w = 25;
			if (i == 2244) {
				topLeft = true; //Top Left
				FragmentSource.x = 0; FragmentSource.y = 0 + ((stage - 1) * 40);
				FragmentTarget[i - 438].x = UFOTarget.x; FragmentTarget[i - 438].y = UFOTarget.y;
			}
			else if (i == 2245) {
				topRight = true; //Top Right
				FragmentSource.x = 25; FragmentSource.y = 0 + ((stage - 1) * 40);
				FragmentTarget[i - 438].x = UFOTarget.x + 25; FragmentTarget[i - 438].y = UFOTarget.y;
			}
			else if (i == 2246) {
				bottomLeft = true;//Bottom Left
				FragmentSource.x = 0; FragmentSource.y = 20 + ((stage - 1) * 40);
				FragmentTarget[i - 438].x = UFOTarget.x; FragmentTarget[i - 438].y = UFOTarget.y + 20;
			}
			else if (i == 2247) {
				bottomRight = true; //Bottom Right
				FragmentSource.x = 25; FragmentSource.y = 20 + ((stage - 1) * 40);
				FragmentTarget[i - 438].x = UFOTarget.x + 25; FragmentTarget[i - 438].y = UFOTarget.y + 20;
			}
		}
		//fragmentRect[1809 - (2247 - i)] = FragmentTarget[i-438];
	}
	virtual void update(int i) {
		if (GlobalReset == false) {
			if (fragmentActive[i - 438] == false) rotateCount = 0;
			//if (fragmentActive[i - 438] == true) active = true;
			//if (active == false && isLeg == false) 
				//FragmentTarget[i-438] = fragmentRect[i - 438];

			//if (active == false && isLeg == true) {
				//FragmentTarget[i-438] = fragmentRect[i - 438];
				//LegStartX = fragmentLegStartX[i - 2046];
				//LegEndX = fragmentLegEndX[i - 2046];
				//LegStartY = fragmentLegStartY[i - 2046];
				//LegEndY = fragmentLegEndY[i - 2046];
		//}
		if (fragmentActive[i-438] == true && isLeg == false) {
			if (topLeft == true) { FragmentTarget[i - 438].x = FragmentTarget[i - 438].x - 7; FragmentTarget[i - 438].y = FragmentTarget[i - 438].y - (7 - rotateCount / 8); }
			if (topRight == true) { FragmentTarget[i - 438].x = FragmentTarget[i - 438].x + 7; FragmentTarget[i - 438].y = FragmentTarget[i - 438].y - (7 - rotateCount / 8); }
			if (bottomLeft == true) { FragmentTarget[i - 438].x = FragmentTarget[i - 438].x - 7; FragmentTarget[i - 438].y = FragmentTarget[i - 438].y + 7 + (rotateCount / 8); }
			if (bottomRight == true) { FragmentTarget[i - 438].x = FragmentTarget[i - 438].x + 7; FragmentTarget[i - 438].y = FragmentTarget[i - 438].y + 7 + (rotateCount / 8); }
			if (midLeft == true) { FragmentTarget[i - 438].x = FragmentTarget[i - 438].x - 7; FragmentTarget[i - 438].y = FragmentTarget[i - 438].y + (rotateCount / 8); }
			if (midRight == true) { FragmentTarget[i - 438].x = FragmentTarget[i - 438].x + 7; FragmentTarget[i - 438].y = FragmentTarget[i - 438].y + (rotateCount / 8); }
			SDL_RenderCopyEx(renderer, FragmentTexture, &FragmentSource, &FragmentTarget[i - 438], rotateCount, NULL, SDL_FLIP_NONE);
			rotateCount = rotateCount + 8;
			if (FragmentTarget[i - 438].x <= 0 || FragmentTarget[i - 438].x >= 1000 ||  FragmentTarget[i - 438].y >= 600) {//FragmentTarget[i - 438].y <= 0 ||
				//active = false;
				fragmentActive[i - 438] = false;
				rotateCount = 0;
			}
			//fragmentRect[i - 438] = FragmentTarget[i-438];
		}
		if (fragmentActive[i - 438] == true && isLeg == true) {
			if (bottomLeft == true) { LegStartX[i - 2046] = LegStartX[i - 2046] - 10; LegEndX[i - 2046] = LegEndX[i - 2046] - 10; LegStartY[i - 2046] = LegStartY[i - 2046] + 10; LegEndY[i - 2046] = LegEndY[i - 2046] + 10; }
			if (middle == true) { LegStartX[i - 2046] = LegStartX[i - 2046] + 5; LegEndX[i - 2046] = LegEndX[i - 2046] + 5; LegStartY[i - 2046] = LegStartY[i - 2046] + 10; LegEndY[i - 2046] = LegEndY[i - 2046] + 10; }
			if (bottomRight == true) { LegStartX[i - 2046] = LegStartX[i - 2046] + 10; LegEndX[i - 2046] = LegEndX[i - 2046] + 10; LegStartY[i - 2046] = LegStartY[i - 2046] + 10; LegEndY[i - 2046] = LegEndY[i - 2046] + 10; }
			//fragmentLegStartX[i - 2046] = LegStartX; fragmentLegEndX[i - 2046] = LegEndX; fragmentLegStartY[i - 2046] = LegStartY; fragmentLegEndY[i - 2046] = LegEndY;
			SDL_SetRenderDrawColor(renderer, 255, 255, 255, 255);
			
			for (int u = 0; u < 2; u++) {
				SDL_RenderDrawLine(renderer, LegStartX[i - 2046] + u, LegStartY[i - 2046], LegEndX[i - 2046] + u, LegEndY[i - 2046]);
			}
			if (LegStartX[i - 2046] <= 0 || LegStartX[i - 2046] >= 1000 || LegStartY[i - 2046] <= 0 || LegStartY[i - 2046] >= 600) {
				//active = false;
				fragmentActive[i - 438] = false;
			}
		}
	}
	//if (GlobalReset == true) {
	//	active = false;
	//	rotateCount = 0;
	//}
}
	virtual void destroy(int i) {
		SDL_FreeSurface(FragmentSurface);
		SDL_DestroyTexture(FragmentTexture);
	}
	Fragment()
	{
	}
	~Fragment()
	{
	}
};

