#pragma once
#include "Thing.h"
#include "Header.h"
class Player :
	public Thing
{
private:
	bool dead;
	int life = 3;
	SDL_Rect PlayerSource;
	SDL_bool collides;
	int PlayerFrame;
	
	bool PlayerDying;
	int i;
	int u;
	int z;
	bool demoTargetSet;
	int demoTargetX;
	int zuffi;
	

public:
	bool extraLife;
	int PlayerPosX = 450;
	int PlayerPosY = 540;
	const int PixPerSec = 100;
	SDL_Texture * PlayerTexture;
	SDL_Surface * PlayerSurface;
	SDL_Rect PlayerTarget;
	Player()
		: dead (false)
	{
	}

	void initPlayer(SDL_Surface * &PlayerSurface, SDL_Texture * &PlayerTexture) {
		SDL_FreeSurface(PlayerSurface);
		SDL_DestroyTexture(PlayerTexture);
		PlayerSurface = SDL_LoadBMP("Player.bmp");//Player
		SDL_SetColorKey(PlayerSurface, SDL_TRUE, SDL_MapRGB(PlayerSurface->format, 255, 0, 255));
		PlayerTexture = SDL_CreateTextureFromSurface(renderer, PlayerSurface);
		PlayerSource.x = 0; PlayerSource.y = 0; PlayerSource.w = 50; PlayerSource.h = 50;
		
	}

	virtual void initiate(int i) {
		PlayerTarget.x = PlayerPosX; PlayerTarget.y = PlayerPosY; PlayerTarget.h = 50; PlayerTarget.w = 50;
		life = 3;
	}
	virtual void update(int i)	{
			PlayerTarget.x = PlayerPosX; PlayerTarget.y = PlayerPosY; PlayerTarget.h = 50; PlayerTarget.w = 50;
			PlayerSource.x = 0;
			if (extraLife == false && score >= 1500) {
				life = life + 1;
				lives = lives + 1;
				extraLife = true;
			}
			
			if (demoMode == true) {
				//move left or right randomly
				if (demoTargetSet == false) {
					srand(SDL_GetTicks()*(SDL_GetTicks()*(time(NULL))*time(NULL)));
					demoTargetX = rand() % 1000 + 1;
					demoTargetSet = true;
				}
				if (demoTargetSet == true) {
					if (PlayerPosX < demoTargetX) {
						PlayerTarget.x = PlayerTarget.x + 5;
						PlayerPosX = PlayerTarget.x;
						if ((demoTargetX - PlayerPosX) < 7) demoTargetSet = false;
					}
					if (PlayerPosX > demoTargetX) {
						PlayerTarget.x = PlayerTarget.x - 5;
						PlayerPosX = PlayerTarget.x;
						if ((PlayerPosX - demoTargetX) < 7) demoTargetSet = false;
					}
				}
				//shoot at random
				if (PlayershotFired == false) {
					srand(SDL_GetTicks()*(SDL_GetTicks()*(time(NULL))*time(NULL)));
					zuffi = rand() % 50 + 1;
					if (zuffi == 10) {
						PlayershotFired = true;
						FX_QUEUE[436] = PLAYERLASER_PUSH;
						GloballaserStartX = PlayerPosX + 19;
						GloballaserStartY = PlayerPosY;
						GloballaserEndX = GloballaserStartX;
						GloballaserEndY = GloballaserStartY;
					}
				}
			}
			for (u = 0; u < 55; u++) {
				collides = SDL_HasIntersection(&PlayerTarget, &enemyLaserRect[u]);
				if (collides == SDL_TRUE) {
					lives = lives - 1;
					collides = SDL_FALSE;
					PlayerDying = true;
					for (z = 0; z < 64; z++) {
						if (FX_QUEUE[z] == SILENCE_PUSH) {
							FX_QUEUE[z] = PLAYEREXPLOSION_PUSH;
							break;
						}
					}
					for (u = 0; u < 55; u++) {
						enemyLaserRect[u].w = 0;
						enemyLaserActive[u] = false;
					}
					PlayershotFired = false;
					PlayerLaserRect.y = 0;
				}
			}
			if (PlayerDying == true) {
				PlayerFrame = PlayerFrame + 1;
				PlayerSource.x = PlayerFrame * 50;
				PlayerTarget.x = PlayerTarget.x - 6; PlayerTarget.w = PlayerTarget.w + 12;
				PlayerTarget.y = PlayerTarget.y - 6; PlayerTarget.h = PlayerTarget.h + 12;
				if (PlayerFrame >= 10) {
					PlayerDying = false;
					playerHit = true;
					PlayerFrame = 0;

					if (lives < 0) {
						Globalgameover = true;
						UFO_active = false;
						extraLife = false;
						if (score >= lowestHighScore) newHighScore = true;
						lives = 0;
						if (demoMode == true) {
							Globalgameover = false;
							restart = true;
							demoMode = false;
						}
					}
				}
			}
			SDL_RenderCopy(renderer, PlayerTexture, &PlayerSource, &PlayerTarget);
	}
	virtual void destroy(int i) {
		SDL_FreeSurface(PlayerSurface);
		SDL_DestroyTexture(PlayerTexture);
	}
	~Player()
	{
	}
};

