#pragma once
#include "Thing.h"
#include "Header.h"
#include <string>

class ScoreFigure:
	public Thing
{
private:
	SDL_Surface *scoreFigure;
	SDL_Rect ScoreFigureTarget;
	SDL_Texture * ScoreFigureTexture;
	SDL_Color textColor;
	//int score;
	std::string scoreString;
	const char *SCORE;
public:
	
	virtual void initiate(int i) {
		textColor = { 255, 255, 255 };
		ScoreFigureTarget.x = 90; ScoreFigureTarget.y = 10; ScoreFigureTarget.h = 20;
	}
	virtual void update(int i) {
		SDL_DestroyTexture(ScoreFigureTexture);
		SDL_FreeSurface(scoreFigure);
		//score = globalScore;
		scoreString = std::to_string(score);
		SCORE = scoreString.c_str();
		scoreFigure = TTF_RenderText_Solid(font, SCORE, textColor);
		ScoreFigureTexture = SDL_CreateTextureFromSurface(renderer, scoreFigure);
		if (score == 0)ScoreFigureTarget.w = 10;
		else if (score >= 10 && score < 100) ScoreFigureTarget.w = 20;
		else if (score >= 100 && score < 1000) ScoreFigureTarget.w = 30;
		else if (score >= 1000) ScoreFigureTarget.w = 40;
		SDL_RenderCopy(renderer, ScoreFigureTexture, NULL, &ScoreFigureTarget);
	}
	virtual void destroy(int i) {
		SDL_DestroyTexture(ScoreFigureTexture);
		SDL_FreeSurface(scoreFigure);
	}
	ScoreFigure()
	{
	}

	~ScoreFigure()
	{
	}
};

